% Lezione di lab TTR  -21/03/2016- PCA - Marco Cristani

% Caricare il file iris.mat
% dataset di 150 oggetti in uno spazio 4-dimensionale
% Calcolare la matrice di trasformazione A utilizzando la Principal Component Analysis
% Ridurre la dimensionalit del dataset a due/tre e visualizzarlo
% visualizzare le varie classi con simboli diversi


clear all
close all
load 'irisSet.mat'


[d,N] = size(X); %numero dim, numero punti
% 1: media
u = mean(X,2);
% 2: centering
h = ones(1,N);
B = X-u*h;
% 3: covariance matrix
C = 1/(N-1) * B*B';
% 4: eigenvalues/eigenvectors
[V,D] = eig(C);
% 5: sort eigenvalues
D=diag(D);
[D,ind]=sort(D,'descend');
V = V(:,ind);
% Una dimensione
% 6: transform matrix
A = V(:,1);
% 6: transformation
Y = A'*B;
% 7: plot su due dimensioni
figure, scatter(Y,ones(1,N),[],l)
set(gcf,'name','1D projection');

% Due dimensioni
% 6: transform matrix
A = V(:,1:2);
% 6: transformation
Y = A'*B;
% 7: plot su due dimensioni
figure, scatter(Y(1,:),Y(2,:),[],l)
set(gcf,'name','2D projection');


% Tre dimensioni
% 6: transform matrix
A = V(:,1:3);
% 6: transformation
Y = A'*B;
% 7: plot su tre dimensioni
figure, scatter3(Y(1,:),Y(2,:),Y(3,:),[],l)
set(gcf,'name','3D projection');


% PLot degli autovalori
figure;
subplot(211)
plot(D); title('Autovalori')
subplot(212)
plot(cumsum(D)/sum(D)); title('Informazione modellata')


%% Eseguire PCA usando un numero M di componenti
% tali che mi codifichino il 95% di informazione
